package sinhala_converter_v3_0;

import java.io.*;
import java.util.ArrayList;
import javax.swing.*;

/**
 * <p>Title: Font Converter</p>
 * <p>Description: Convert ASCII font text files to Unicode text files</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: UCSC</p>
 * @author Viraj Welgama
 * @version 2.1
 */

public class InitialReader {

  /** Take system massages */
  String massage = "";

  JProgressBar progressBar1;

  public InitialReader() {}

  public InitialReader(String path, String fName, String OutputPath,
                       JProgressBar progressBar1, RandomAccessFile raf) {

    /** Catch Error Massages */
    boolean ok = true;
    boolean isUnicode;

    try {

      /** Object for read lookup table */
      TableReader tr = new TableReader();

      /** Data form looup table */
      String[] lookUpTableResults = tr.fileOut(fName);

      /** To keep converted unicode data */
      ArrayList ConvertedData = new ArrayList(1);

      /** Integer objects for write resultant data */
      Integer forData = new Integer(0);

      /** Counters */
      int Counter = 0;
      int length = 0;

      int originalintData[] = new int[1];
      byte originalData[] = new byte[1];

      FileInputStream fis = new FileInputStream(path);
      DataInputStream fin = new DataInputStream(fis);

      if(fin.read()==Integer.parseInt("ff",16) && fin.read()==Integer.parseInt("fe",16))
         isUnicode = true;
        else
        isUnicode = false;


      if(isUnicode) {
      /** Get int values form Input (source) file */
      UnicodeToASCII ua = new UnicodeToASCII();
      originalintData = ua.readInt(path);
      length = originalintData.length;
      }
      else {
        /** Input (source) file */
      fis = new FileInputStream(new File(path));
      /** To recieve data from original file */
      originalData = new byte[fis.available()];
      /** Read original data from input file */
      fis.read(originalData);
      length = originalData.length;
      }

      progressBar1.setValue(1);
      /** Read original data & covert them to unicode */
      for (int i = 0; i < length; i++) {
        if(isUnicode)
          Counter = originalintData[i];
          else
        Counter = (originalData[i] < 0) ? originalData[i] + 256 :
            originalData[i];

        /** Break lookup table data as seperate characters */
        switch (lookUpTableResults[Counter].length()) {
          case 4:
            if (lookUpTableResults[Counter].equals("RJCT"))
              break;
            ConvertedData.add(lookUpTableResults[Counter]);
            break;
          case 9:
            ConvertedData.add(lookUpTableResults[Counter].substring(0, 4));
            ConvertedData.add(lookUpTableResults[Counter].substring(5, 9));
            break;
          case 14:
            ConvertedData.add(lookUpTableResults[Counter].substring(0, 4));
            ConvertedData.add(lookUpTableResults[Counter].substring(5, 9));
            ConvertedData.add(lookUpTableResults[Counter].substring(10,
                14));
            break;
          case 19:
            ConvertedData.add(lookUpTableResults[Counter].substring(0, 4));
            ConvertedData.add(lookUpTableResults[Counter].substring(5, 9));
            ConvertedData.add(lookUpTableResults[Counter].substring(10,
                14));
            ConvertedData.add(lookUpTableResults[Counter].substring(15,
                19));
            break;
          case 24:
            ConvertedData.add(lookUpTableResults[Counter].substring(0, 4));
            ConvertedData.add(lookUpTableResults[Counter].substring(5, 9));
            ConvertedData.add(lookUpTableResults[Counter].substring(10,
                14));
            ConvertedData.add(lookUpTableResults[Counter].substring(15,
                19));
            ConvertedData.add(lookUpTableResults[Counter].substring(20,
                24));
            break;
          case 29:
            ConvertedData.add(lookUpTableResults[Counter].substring(0, 4));
            ConvertedData.add(lookUpTableResults[Counter].substring(5, 9));
            ConvertedData.add(lookUpTableResults[Counter].substring(10,
                14));
            ConvertedData.add(lookUpTableResults[Counter].substring(15,
                19));
            ConvertedData.add(lookUpTableResults[Counter].substring(20,
                24));
            ConvertedData.add(lookUpTableResults[Counter].substring(25,
                29));
            break;

          default:
            ConvertedData.add("Sorry" +
                                     lookUpTableResults[Counter].length());
        } //switch

      } //for

      /** to confirm the size of file */
      boolean go = true;

      if (ConvertedData.size() > 1300000) {
        JOptionPane.showMessageDialog(new SinConV3Frame(), "The input file is too large to convert.\nBreak the file into small files and retry.",
                                      "Error!",
                                      JOptionPane.ERROR_MESSAGE);
        massage = "Convertion failed!";
        try {
          raf.close();
          new File(OutputPath).delete();
        } //try
        catch (IOException io) {
          System.out.println("Sorry! File missing.");
        } //catch
        go = false;
        ok = false;
      } // if >1300000

      else if (ConvertedData.size() > 1200000) {
        int k = JOptionPane.showConfirmDialog(new SinConV3Frame(),
                                              "The input file is too large to convert\nand the converter may give out of memory error.\nIt is recommended you to break the file into small files and retry."
                                              +
            "\nDo you want to continue anyway?",
            "A Follow-up Question -",
            JOptionPane.YES_NO_OPTION);
        if (k == JOptionPane.NO_OPTION) {
          massage = "Convertion aborted!";
          try {
            raf.close();
            new File(OutputPath).delete();
          } //try
          catch (IOException io) {
            System.out.println("Sorry! File missing.");
          } //catch
          go = false;
          ok = false;
        }
        else
          JOptionPane.showMessageDialog(new SinConV3Frame(), "Depending on your systems speed and capacity\nthis process may take up to several minutes",
                              "Worning -",
                              JOptionPane.WARNING_MESSAGE);

      } // if>1200000

        else if(ConvertedData.size() > 1000000)
          JOptionPane.showMessageDialog(new SinConV3Frame(), "Depending on your systems speed and capacity\nthis process may take up to several minutes",
                                        "Worning -",
                                        JOptionPane.WARNING_MESSAGE);

       if (go) {

        progressBar1.setValue(2);
        /** Object for narmalize unicode data */
        Normalizer nm = new Normalizer(ConvertedData);

        /** Normalize unicode data by 4 parsers */
        nm.normalize1();
        progressBar1.setValue(3);

        nm.normalize2();
        progressBar1.setValue(8);

        nm.cleanUp();
        progressBar1.setValue(9);

        nm.normalize3();
        progressBar1.setValue(10);

        nm.normalize4();
        progressBar1.setValue(11);

        /** Convert data to smallendian format */
        try {
          passer(ConvertedData);
          progressBar1.setValue(12);
        }
        catch (java.lang.OutOfMemoryError ou) {
          massage = "Your machine is running with out of memory.";
          ok = false;
        }
        if (ok) {

          progressBar1.setValue(13);

          /** Write output data to the file */
          for (int i = 0; i < ConvertedData.size(); i++) {
            forData = Integer.valueOf(ConvertedData.get(i).toString(), 16);
            raf.writeChar(forData.intValue());
          } // write result file

          progressBar1.setValue(14);

          /** Close the output file */
          raf.close();
        } //ok
      } // go
    } //try

    catch (IOException e) {
      massage = e.toString();
      ok = false;
    }
    catch (ArrayIndexOutOfBoundsException e) {
      massage = "Sorry! Internal Error";
      ok = false;
    }

    /** Finishing massage */
    if (ok)
      massage = "Successfully converted !";

  } //constructor

  void delete() {

 } //delete

  /** Function to convert unicode as smallendian */
  private static void passer(ArrayList v) throws java.lang.OutOfMemoryError {
    String Btemp = "";
    String Atemp = "";
    for (int i = 0; i < v.size(); i++) {
      Btemp = v.get(i).toString();
      Atemp = Btemp.substring(2);
      Atemp = Atemp.concat(Btemp.substring(0, 2));
      v.set(i, Atemp);
    }
  } //passer

  public String printMassage() {
    return massage;
  }

} //calss