package sinhala_converter_v3_0;

import java.io.*;
import java.util.ArrayList;
import javax.swing.*;

/**
 * <p>Title: Font Converter</p>
 * <p>Description: Convert ASCII font text files to Unicode text files</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: UCSC</p>
 * @author Viraj Welgama
 * @version 2.1
 */

public class InitialReaderGr {

  /** Take system massages */
  static String massage = "";

    JProgressBar progressBar1;

  /** Data form looup table */
  private ArrayList lookupIndex;
  private ArrayList lookupValues;

  public InitialReaderGr() {}

  public InitialReaderGr(String path, String fName, String OutputPath,
                       JProgressBar progressBar1, RandomAccessFile raf) {

    /** Catch Error Massages */
    boolean ok = true;

    try {

      /** To read source data */
      ArrayList sourceData = UnicodeFileReWriter.reader(path);
      ArrayList rest = new ArrayList(1);
      /**Load lookup tables */
      getMaps(fName);

      /** To keep converted unicode data */
      ArrayList ConvertedData = new ArrayList(1);

      /** Integer objects for write resultant data */
      Integer forData = new Integer(0);
      String code = "";

      progressBar1.setValue(1);

      for(int i=0; i<sourceData.size(); i++) {
      if(sourceData.get(i).toString().startsWith("e1")) {
         if(lookupIndex.contains(sourceData.get(i).toString())) {
           code = lookupValues.get(lookupIndex.indexOf(sourceData.get(i).
               toString())).toString();

           /** Break lookup table data as seperate characters */
           switch (code.length()) {
             case 4:
               if (code.equals("RJCT"))
                 break;
               ConvertedData.add(code);
               break;
             case 9:
               ConvertedData.add(code.substring(0, 4));
               ConvertedData.add(code.substring(5, 9));
               break;
             case 14:
               ConvertedData.add(code.substring(0, 4));
               ConvertedData.add(code.substring(5, 9));
               ConvertedData.add(code.substring(10,
                                                14));
               break;
             case 19:
               ConvertedData.add(code.substring(0, 4));
               ConvertedData.add(code.substring(5, 9));
               ConvertedData.add(code.substring(10,
                                                14));
               ConvertedData.add(code.substring(15,
                                                19));
               break;
             default:
               ConvertedData.add("Sorry" +
                                 code.length());
           } //switch
         }
       else
          rest.add(sourceData.get(i).toString());
      }
      else
        ConvertedData.add(sourceData.get(i).toString());
      }//for

      /** to confirm the size of file */
      boolean go = true;

      if (ConvertedData.size() > 1300000) {
        JOptionPane.showMessageDialog(new SinConV3Frame(), "The input file is too large to convert.\nBreak the file into small files and retry.",
                                      "Error!",
                                      JOptionPane.ERROR_MESSAGE);
        massage = "Convertion failed!";
        try {
          raf.close();
          new File(OutputPath).delete();
        } //try
        catch (IOException io) {
          System.out.println("Sorry! File missing.");
        } //catch
        go = false;
        ok = false;
      } // if >1300000

      else if (ConvertedData.size() > 1200000) {
        int k = JOptionPane.showConfirmDialog(new SinConV3Frame(),
                                              "The input file is too large to convert\nand the converter may give out of memory error.\nIt is recommended you to break the file into small files and retry."
                                              +
            "\nDo you want to continue anyway?",
            "A Follow-up Question -",
            JOptionPane.YES_NO_OPTION);
        if (k == JOptionPane.NO_OPTION) {
          massage = "Convertion aborted!";
          try {
            raf.close();
            new File(OutputPath).delete();
          } //try
          catch (IOException io) {
            System.out.println("Sorry! File missing.");
          } //catch
          go = false;
          ok = false;
        }
        else
          JOptionPane.showMessageDialog(new SinConV3Frame(), "Depending on your systems speed and capacity\nthis process may take up to several minutes",
                              "Worning -",
                              JOptionPane.WARNING_MESSAGE);

      } // if>1200000

        else if(ConvertedData.size() > 1000000)
          JOptionPane.showMessageDialog(new SinConV3Frame(), "Depending on your systems speed and capacity\nthis process may take up to several minutes",
                                        "Worning -",
                                        JOptionPane.WARNING_MESSAGE);

        if (go) {

         progressBar1.setValue(2);

        /** Object for narmalize unicode data */
        Normalizer nm = new Normalizer(ConvertedData);

        /** Normalize unicode data by 4 parsers */
        nm.normalize1();
        progressBar1.setValue(3);
        nm.normalize2();
        progressBar1.setValue(8);
        nm.cleanUp();
        progressBar1.setValue(9);
        nm.normalize3();
        progressBar1.setValue(10);
        nm.normalize4();
        progressBar1.setValue(11);

        /** Convert data to smallendian format */
        try {
          passer(ConvertedData);
          progressBar1.setValue(12);
        }
        catch (java.lang.OutOfMemoryError ou) {
          massage = "Your machine is running with out of memory.";
          ok = false;
        }
        if (ok) {

          progressBar1.setValue(13);

          /** Write output data to the file */
          for (int i = 0; i < ConvertedData.size(); i++) {
            forData = Integer.valueOf(ConvertedData.get(i).toString(), 16);
            raf.writeChar(forData.intValue());
          } // write result file

          progressBar1.setValue(14);

          /** Close the output file */
          raf.close();
        } //ok
 }//go
    } //try

    catch (IOException e) {
      massage = e.toString();
      ok = false;
    }
    catch (ArrayIndexOutOfBoundsException e) {
      massage = "Sorry! Internal Error";
      ok = false;
    }

    /** Finishing massage */
    if (ok)
      massage = "Successfully converted !";

  } //constructor

  /** Function to convert unicode as smallendian */
  private static void passer(ArrayList v) throws java.lang.OutOfMemoryError {
    String Btemp = "";
    String Atemp = "";
    for (int i = 0; i < v.size(); i++) {
      Btemp = v.get(i).toString();
      Atemp = Btemp.substring(2);
      Atemp = Atemp.concat(Btemp.substring(0, 2));
      v.set(i, Atemp);
    }
  } //passer

  public String printMassage() {
    return massage;
  }

  private void getMaps(String path) throws java.io.IOException {
    lookupIndex = new ArrayList(1);
    lookupValues = new ArrayList(1);
    FileInputStream fis = new FileInputStream(path);
    DataInputStream fin = new DataInputStream(fis);
    int i = 0;
    String line = fin.readLine();
    while (true) {
      line = fin.readLine();
      if (line == null) {
        line = "End Of file";
        break;
      }
      else
      if (line.length() == 0)
        continue;
      lookupIndex.add(line.substring(0,4));
      lookupValues.add(line.substring(5));
      i++;
    } //while
  } //getMaps

} //calss