package sinhala_converter_v3_0;

/** This reads Unicode characters form Unicode format file and prints them */
/** Author: Viraj Welgama
 * LTRL - UCSC
 * March 2005
 */

import java.io.*;
import java.util.ArrayList;

class UnicodeToASCII {

  public int[] readInt(String path) {
    int[] error = new int[1];
    try {

      FileInputStream fis = new FileInputStream(path);
      DataInputStream fin = new DataInputStream(fis);

      fin.read();
      fin.read();

      ArrayList data = new ArrayList(1);
      int limit = fin.available() / 2;

      for (int i = 0; i < limit; i++) {
        data.add(new Integer(fin.read()));
        fin.read();
      }

      int[] values = new int[data.size()];

      for (int i = 0; i < data.size(); i++)
        values[i] = Integer.parseInt(data.get(i).toString());
      return values;
    } //try

    catch (FileNotFoundException fnf) {
      System.out.println("Sorry!, The file not found.");
      return error;
    }
    catch (IOException io) {
      System.out.println(io.toString());
      io.printStackTrace(System.err);
      return error;
    }

  } //readInt
} //class